## logiops 0.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(CMAKE_INSTALL_PREFIX /usr)

project(logiops)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -Wall -Wextra")

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Git)

# Set version number
if(GIT_FOUND AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
    execute_process(COMMAND ${GIT_EXECUTABLE} describe
         OUTPUT_VARIABLE LOGIOPS_VERSION
         RESULT_VARIABLE LOGIOPS_VERSION_RET
         ERROR_QUIET)
    if(NOT LOGIOPS_VERSION_RET EQUAL "0")
        execute_process(COMMAND ${GIT_EXECUTABLE}
            rev-parse --short HEAD
            OUTPUT_VARIABLE LOGIOPS_COMMIT_HASH)
        set(LOGIOPS_VERSION git-${LOGIOPS_COMMIT_HASH})
    endif()
    string(REGEX REPLACE "\n$" "" LOGIOPS_VERSION ${LOGIOPS_VERSION})
elseif(EXISTS ${CMAKE_SOURCE_DIR}/version.txt)
    file(READ version.txt LOGIOPS_VERSION)
    string(REGEX REPLACE "\n$" "" LOGIOPS_VERSION ${LOGIOPS_VERSION})
endif()

if(NOT LOGIOPS_VERSION)
    set(LOGIOPS_VERSION "null")
endif()
message("LogiOps Version Number: ${LOGIOPS_VERSION}")

add_definitions( -DLOGIOPS_VERSION="${LOGIOPS_VERSION}")

add_subdirectory(src/logid)

=== src/logid/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(logid)

set(CMAKE_CXX_STANDARD 14)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../CMake")

find_package(Threads REQUIRED)
find_package(PkgConfig REQUIRED)

add_executable(logid
        logid.cpp
        util/log.cpp
        InputDevice.cpp
        DeviceManager.cpp
        Device.cpp
        Receiver.cpp
        Configuration.cpp
        features/DPI.cpp
        features/SmartShift.cpp
        features/HiresScroll.cpp
        features/RemapButton.cpp
        features/DeviceStatus.cpp
        actions/Action.cpp
        actions/NullAction.cpp
        actions/KeypressAction.cpp
        actions/ToggleHiresScroll.cpp
        actions/ToggleSmartShift.cpp
        actions/CycleDPI.cpp
        actions/ChangeDPI.cpp
        actions/GestureAction.cpp
        actions/ChangeHostAction.cpp
        actions/gesture/Gesture.cpp
        actions/gesture/ReleaseGesture.cpp
        actions/gesture/IntervalGesture.cpp
        actions/gesture/AxisGesture.cpp
        actions/gesture/NullGesture.cpp
        backend/Error.cpp
        backend/raw/DeviceMonitor.cpp
        backend/raw/RawDevice.cpp
        backend/dj/Receiver.cpp
        backend/dj/ReceiverMonitor.cpp
        backend/dj/Error.cpp
        backend/hidpp/Device.cpp
        backend/hidpp/Report.cpp
        backend/hidpp10/Error.cpp
        backend/hidpp10/Device.cpp
        backend/hidpp20/Device.cpp
        backend/hidpp20/Error.cpp
        backend/hidpp20/Feature.cpp
        backend/hidpp20/EssentialFeature.cpp
        backend/hidpp20/features/Root.cpp
        backend/hidpp20/features/FeatureSet.cpp
        backend/hidpp20/features/DeviceName.cpp
        backend/hidpp20/features/Reset.cpp
        backend/hidpp20/features/AdjustableDPI.cpp
        backend/hidpp20/features/SmartShift.cpp
        backend/hidpp20/features/ReprogControls.cpp
        backend/hidpp20/features/HiresScroll.cpp
        backend/hidpp20/features/ChangeHost.cpp
        backend/hidpp20/features/WirelessDeviceStatus.cpp
        backend/dj/Report.cpp
        util/mutex_queue.h
        util/workqueue.cpp
        util/worker_thread.cpp
        util/task.cpp
        util/thread.cpp
        util/ExceptionHandler.cpp)

set_target_properties(logid PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

pkg_check_modules(PC_EVDEV libevdev REQUIRED)
pkg_check_modules(SYSTEMD "systemd")
pkg_check_modules(LIBCONFIG libconfig REQUIRED)
pkg_check_modules(LIBUDEV libudev REQUIRED)

find_path(EVDEV_INCLUDE_DIR libevdev/libevdev.h
          HINTS ${PC_EVDEV_INCLUDE_DIRS} ${PC_EVDEV_INCLUDEDIR})
find_library(EVDEV_LIBRARY
        NAMES evdev libevdev)

include_directories(${EVDEV_INCLUDE_DIR} ${LIBUDEV_INCLUDE_DIRECTORIES})

target_link_libraries(logid ${CMAKE_THREAD_LIBS_INIT} ${EVDEV_LIBRARY} config++
        ${LIBUDEV_LIBRARIES})

install(TARGETS logid DESTINATION bin)

if (SYSTEMD_FOUND AND "${SYSTEMD_SERVICES_INSTALL_DIR}" STREQUAL "")
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE}
        --variable=systemdsystemunitdir systemd
        OUTPUT_VARIABLE SYSTEMD_SERVICES_INSTALL_DIR)
    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SERVICES_INSTALL_DIR
           "${SYSTEMD_SERVICES_INSTALL_DIR}")
    configure_file(logid.service.cmake ${CMAKE_BINARY_DIR}/logid.service)
    message(STATUS "systemd units will be installed at ${SYSTEMD_SERVICES_INSTALL_DIR}")
    install(FILES ${CMAKE_BINARY_DIR}/logid.service
            DESTINATION ${SYSTEMD_SERVICES_INSTALL_DIR}
            COMPONENT cp)
elseif(NOT SYSTEMD_FOUND AND SYSTEMD_SERVICES_INSTALL_DIR)
    message(FATAL_ERROR "systemd is not found w/ pkg-config but SYSTEMD_SERVICES_INSTALL_DIR is defined.")
endif()

=== debian/changelog ===
logiops (0.2.2-2) unstable; urgency=medium

  * [10ba78c] Install TESTED.md into /usr/share/docs.
    Thanks Norbert Kiesel (Closes: #984836)
  * [6e39e49] Patch to fix missing #include for std::this_thread::sleep_for
    (Closes: #997234)

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 09 Mar 2021 10:32:20 +0800

logiops (0.2.2-1) unstable; urgency=medium

  * Initial release (Closes: #983164)

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 20 Feb 2021 18:27:06 +0800

=== debian/control ===
Source: logiops
Section: misc
Priority: optional
Maintainer: Chow Loong Jin <hyperair@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-exec,
               libevdev-dev,
               libudev-dev,
               libconfig++-dev,
               systemd
Standards-Version: 4.5.0
Homepage: https://github.com/PixlOne/logiops
Vcs-Browser: https://salsa.debian.org/debian/logiops
Vcs-Git: https://salsa.debian.org/debian/logiops.git
Rules-Requires-Root: no

Package: logiops
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Configuration utility for Logitech mice and keyboards
 logiops is a configuration utility (similar to Logitech Control Center and
 Solaar) for Logitech mice and keyboards. Unlike Solaar, it does not support
 management of the Unifying Receiver, but only HID++ 2.0+ devices. Known
 supported models are:
  - MX Master 3
  - MX Master 2S
  - MX Master
  - MX Vertical
  - MX Ergo
  - M720
  - M590
  - T400

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"


 GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/PixlOne/logiops/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## logiops 0.2.3

=== src/logid/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
         features/HiresScroll.cpp
         features/RemapButton.cpp
         features/DeviceStatus.cpp
+        features/ThumbWheel.cpp
         actions/Action.cpp
         actions/NullAction.cpp
         actions/KeypressAction.cpp
@@ -32,6 +33,7 @@
         actions/ChangeHostAction.cpp
         actions/gesture/Gesture.cpp
         actions/gesture/ReleaseGesture.cpp
+        actions/gesture/ThresholdGesture.cpp
         actions/gesture/IntervalGesture.cpp
         actions/gesture/AxisGesture.cpp
         actions/gesture/NullGesture.cpp
@@ -59,6 +61,7 @@
         backend/hidpp20/features/HiresScroll.cpp
         backend/hidpp20/features/ChangeHost.cpp
         backend/hidpp20/features/WirelessDeviceStatus.cpp
+        backend/hidpp20/features/ThumbWheel.cpp
         backend/dj/Report.cpp
         util/mutex_queue.h
         util/workqueue.cpp

=== debian/changelog ===
logiops (0.2.3-1) unstable; urgency=medium

  * [71c101e] Drop uupdate from debian/watch
  * [8ad709b] New upstream version 0.2.3
    - Fixes issue with mouse mapping in newer systemd versions
      (Closes: #1010156)
  * [e58d734] Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 28 Apr 2022 16:42:52 +0800

=== debian/watch ===
--- 
+++ 
@@ -10,4 +10,4 @@
  GitHub hosted projects
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
    https://github.com/PixlOne/logiops/tags \
-   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
+   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

## logiops 0.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_INSTALL_PREFIX /usr)

project(logiops)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -Wall -Wextra")

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(USE_USER_BUS "Uses user bus" OFF)

find_package(Git)

# Set version number and update submodules
if(EXISTS ${PROJECT_SOURCE_DIR}/.git AND GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags
         OUTPUT_VARIABLE LOGIOPS_VERSION
         RESULT_VARIABLE LOGIOPS_VERSION_RET
         WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
         ERROR_QUIET)
    if(NOT LOGIOPS_VERSION_RET EQUAL "0")
        execute_process(COMMAND ${GIT_EXECUTABLE}
            rev-parse --short HEAD
            OUTPUT_VARIABLE LOGIOPS_COMMIT_HASH)
        set(LOGIOPS_VERSION git-${LOGIOPS_COMMIT_HASH})
    endif()

    execute_process(COMMAND ${GIT_EXECUTABLE}
            submodule update --init --recursive
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

    string(REGEX REPLACE "\n$" "" LOGIOPS_VERSION ${LOGIOPS_VERSION})
elseif(EXISTS ${PROJECT_SOURCE_DIR}/version.txt)
    file(READ version.txt LOGIOPS_VERSION)
    string(REGEX REPLACE "\n$" "" LOGIOPS_VERSION ${LOGIOPS_VERSION})

endif()

IF(NOT EXISTS ${PROJECT_SOURCE_DIR}/src/ipcgull)
    message(FATAL_ERROR "Missing ipcgull submodule")
endif()

if(NOT LOGIOPS_VERSION)
    set(LOGIOPS_VERSION "null")
endif()
message("LogiOps Version Number: ${LOGIOPS_VERSION}")

add_definitions( -DLOGIOPS_VERSION="${LOGIOPS_VERSION}")

if(USE_USER_BUS)
    add_definitions(-DUSE_USER_BUS)
endif()

add_subdirectory(src/ipcgull)
add_subdirectory(src/logid)

=== src/ipcgull/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(ipcgull)

set(CMAKE_CXX_STANDARD 17)

find_package(PkgConfig REQUIRED)

# In the future, we should create a better mechanism to change this.
if (${IPCGULL_STUB})
    set(IPCGULL_BACKEND_SRC src/server_stub.cpp)
else ()
    set(IPCGULL_BACKEND_SRC src/common_gdbus.cpp src/server_gdbus.cpp)
    pkg_check_modules(GIO REQUIRED gio-2.0)
    pkg_check_modules(GLIB REQUIRED glib-2.0)
    set(IPCGULL_BACKEND_INCLUDE ${GIO_INCLUDE_DIRS} ${GLIB_INCLUDE_DIRS})
    set(IPCGULL_BACKEND_LIBRARIES ${GIO_LIBRARIES} ${GLIB_LIBRARIES})
endif ()

include_directories(src/include/ ${IPCGULL_BACKEND_INCLUDE})
add_library(ipcgull
        src/function.cpp
        src/property.cpp
        src/signal.cpp
        src/interface.cpp
        src/node.cpp
        src/exception.cpp
        ${IPCGULL_BACKEND_SRC})
target_link_libraries(ipcgull ${IPCGULL_BACKEND_LIBRARIES})

if (${BUILD_TESTS})
    add_subdirectory(tests/server_test)
endif ()

=== src/logid/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,9 @@
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.12)
 project(logid)
 
-set(CMAKE_CXX_STANDARD 14)
+# C++20 is only needed for string literal template parameters
+set(CMAKE_CXX_STANDARD 20)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../CMake")
 
@@ -11,6 +13,7 @@
 add_executable(logid
         logid.cpp
         util/log.cpp
+        config/config.cpp
         InputDevice.cpp
         DeviceManager.cpp
         Device.cpp
@@ -31,6 +34,7 @@
         actions/ChangeDPI.cpp
         actions/GestureAction.cpp
         actions/ChangeHostAction.cpp
+        actions/ChangeProfile.cpp
         actions/gesture/Gesture.cpp
         actions/gesture/ReleaseGesture.cpp
         actions/gesture/ThresholdGesture.cpp
@@ -40,9 +44,9 @@
         backend/Error.cpp
         backend/raw/DeviceMonitor.cpp
         backend/raw/RawDevice.cpp
-        backend/dj/Receiver.cpp
-        backend/dj/ReceiverMonitor.cpp
-        backend/dj/Error.cpp
+        backend/raw/IOMonitor.cpp
+        backend/hidpp10/Receiver.cpp
+        backend/hidpp10/ReceiverMonitor.cpp
         backend/hidpp/Device.cpp
         backend/hidpp/Report.cpp
         backend/hidpp10/Error.cpp
@@ -62,44 +66,58 @@
         backend/hidpp20/features/ChangeHost.cpp
         backend/hidpp20/features/WirelessDeviceStatus.cpp
         backend/hidpp20/features/ThumbWheel.cpp
-        backend/dj/Report.cpp
-        util/mutex_queue.h
-        util/workqueue.cpp
-        util/worker_thread.cpp
         util/task.cpp
-        util/thread.cpp
         util/ExceptionHandler.cpp)
 
 set_target_properties(logid PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
 
 pkg_check_modules(PC_EVDEV libevdev REQUIRED)
+pkg_check_modules(DBUS "dbus-1")
 pkg_check_modules(SYSTEMD "systemd")
 pkg_check_modules(LIBCONFIG libconfig REQUIRED)
 pkg_check_modules(LIBUDEV libudev REQUIRED)
 
 find_path(EVDEV_INCLUDE_DIR libevdev/libevdev.h
-          HINTS ${PC_EVDEV_INCLUDE_DIRS} ${PC_EVDEV_INCLUDEDIR})
+        HINTS ${PC_EVDEV_INCLUDE_DIRS} ${PC_EVDEV_INCLUDEDIR})
 find_library(EVDEV_LIBRARY
         NAMES evdev libevdev)
 
-include_directories(${EVDEV_INCLUDE_DIR} ${LIBUDEV_INCLUDE_DIRECTORIES})
+set(IPCGULL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../ipcgull/src/include)
+message(${IPCGULL_INCLUDE_DIRS})
+
+include_directories(. ${EVDEV_INCLUDE_DIR} ${LIBUDEV_INCLUDE_DIRECTORIES} ${IPCGULL_INCLUDE_DIRS})
 
 target_link_libraries(logid ${CMAKE_THREAD_LIBS_INIT} ${EVDEV_LIBRARY} config++
-        ${LIBUDEV_LIBRARIES})
+        ${LIBUDEV_LIBRARIES} ipcgull)
 
 install(TARGETS logid DESTINATION bin)
 
-if (SYSTEMD_FOUND AND "${SYSTEMD_SERVICES_INSTALL_DIR}" STREQUAL "")
-    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE}
-        --variable=systemdsystemunitdir systemd
-        OUTPUT_VARIABLE SYSTEMD_SERVICES_INSTALL_DIR)
-    string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SERVICES_INSTALL_DIR
-           "${SYSTEMD_SERVICES_INSTALL_DIR}")
-    configure_file(logid.service.cmake ${CMAKE_BINARY_DIR}/logid.service)
+if (SYSTEMD_FOUND)
+    if ("${SYSTEMD_SERVICES_INSTALL_DIR}" STREQUAL "")
+        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE}
+                --variable=systemdsystemunitdir systemd
+                OUTPUT_VARIABLE SYSTEMD_SERVICES_INSTALL_DIR)
+        string(REGEX REPLACE "[ \t\n]+" "" SYSTEMD_SERVICES_INSTALL_DIR
+                "${SYSTEMD_SERVICES_INSTALL_DIR}")
+    endif ()
+
+    # Install systemd service
+    configure_file(logid.service.in ${CMAKE_BINARY_DIR}/logid.service)
     message(STATUS "systemd units will be installed at ${SYSTEMD_SERVICES_INSTALL_DIR}")
     install(FILES ${CMAKE_BINARY_DIR}/logid.service
             DESTINATION ${SYSTEMD_SERVICES_INSTALL_DIR}
             COMPONENT cp)
-elseif(NOT SYSTEMD_FOUND AND SYSTEMD_SERVICES_INSTALL_DIR)
+elseif (NOT SYSTEMD_FOUND AND SYSTEMD_SERVICES_INSTALL_DIR)
     message(FATAL_ERROR "systemd is not found w/ pkg-config but SYSTEMD_SERVICES_INSTALL_DIR is defined.")
+endif ()
+
+if(DBUS_FOUND)
+    # Install DBus conf
+    # TODO: Is there a better way of setting the system policy directory?
+    set(DBUS_SYSTEM_POLICY_INSTALL_DIR "/usr/share/dbus-1/system.d")
+    configure_file(logiops-dbus.conf.in ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf)
+    message(STATUS "dbus system policy will be installed at ${DBUS_SYSTEM_POLICY_INSTALL_DIR}")
+    install(FILES ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf
+            DESTINATION ${DBUS_SYSTEM_POLICY_INSTALL_DIR}
+            COMPONENT cp)
 endif()

=== src/ipcgull/tests/server_test/CMakeLists.txt ===
add_executable(server_test main.cpp)

find_package(Threads REQUIRED)

target_link_libraries(server_test ipcgull ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
logiops (0.3.1-1) unstable; urgency=medium

  * [be64a76] Build-dep on git
  * [70b745c] Update watch file to use CI-uploaded release tarball
  * [c75c180] New upstream version 0.3.1
  * [007e901] Build-dep on libglib2.0-dev
  * [c514d55] Fix up autopkgtests

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 05 May 2023 17:25:18 +0800

logiops (0.3.0-1) UNRELEASED; urgency=medium

  * [72b779c] Fix accidentally uncommented line in watch file
  * [9d3beb3] New upstream version 0.3.0
  * [901fda4] Add autopkgtests
  * [1fc3023] Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 04 May 2023 11:02:18 +0800

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,9 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                dh-exec,
+               git,
                libevdev-dev,
+               libglib2.0-dev,
                libudev-dev,
                libconfig++-dev,
                systemd

=== debian/tests/control ===
Tests: check-logid
Depends: @, dbus | dbus-system-bus
Restrictions: needs-root, allow-stderr

## logiops 0.3.2

=== debian/changelog ===
logiops (0.3.2-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 19 Jun 2023 14:37:55 +0800

logiops (0.3.2-1) experimental; urgency=medium

  * [164e5de] New upstream version 0.3.2
  * [ee14f8c] Refresh patches
  * [9c4d612] Simplify autopkgtests
    logid won't launch without access to /dev/uinput, so it's impossible to do
    the no-crash test

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 30 May 2023 17:45:11 +0800

## logiops 0.3.3

=== src/ipcgull/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,9 @@
 set(CMAKE_CXX_STANDARD 17)
 
 find_package(PkgConfig REQUIRED)
+
+option(BUILD_SHARED "build shared library" OFF)
+option(BUILD_STATIC "build static library" ON)
 
 # In the future, we should create a better mechanism to change this.
 if (${IPCGULL_STUB})
@@ -16,16 +19,37 @@
     set(IPCGULL_BACKEND_LIBRARIES ${GIO_LIBRARIES} ${GLIB_LIBRARIES})
 endif ()
 
+MESSAGE(STATUS "  Build shared library:          " ${BUILD_SHARED})
+MESSAGE(STATUS "  Build static library:          " ${BUILD_STATIC})
+
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
 include_directories(src/include/ ${IPCGULL_BACKEND_INCLUDE})
-add_library(ipcgull
-        src/function.cpp
-        src/property.cpp
-        src/signal.cpp
-        src/interface.cpp
-        src/node.cpp
-        src/exception.cpp
-        ${IPCGULL_BACKEND_SRC})
+
+set(ipcgull_src
+    src/function.cpp
+    src/property.cpp
+    src/signal.cpp
+    src/interface.cpp
+    src/node.cpp
+    src/exception.cpp
+    ${IPCGULL_BACKEND_SRC}
+)
+
+add_library(ipcgull OBJECT ${ipcgull_src})
 target_link_libraries(ipcgull ${IPCGULL_BACKEND_LIBRARIES})
+
+if (BUILD_SHARED)
+    add_library(ipcgull_shared SHARED $<TARGET_OBJECTS:ipcgull>)
+    target_link_libraries(ipcgull_shared PUBLIC $<TARGET_PROPERTY:ipcgull,LINK_LIBRARIES>)
+    set_target_properties(ipcgull_shared PROPERTIES OUTPUT_NAME ipcgull)
+endif()
+
+if (BUILD_STATIC)
+    add_library(ipcgull_static STATIC $<TARGET_OBJECTS:ipcgull>)
+    target_link_libraries(ipcgull_static PUBLIC $<TARGET_PROPERTY:ipcgull,LINK_LIBRARIES>)
+    set_target_properties(ipcgull_static PROPERTIES OUTPUT_NAME ipcgull)
+endif()
 
 if (${BUILD_TESTS})
     add_subdirectory(tests/server_test)

=== src/logid/CMakeLists.txt ===
--- 
+++ 
@@ -72,7 +72,6 @@
 set_target_properties(logid PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
 
 pkg_check_modules(PC_EVDEV libevdev REQUIRED)
-pkg_check_modules(DBUS "dbus-1")
 pkg_check_modules(SYSTEMD "systemd")
 pkg_check_modules(LIBCONFIG libconfig REQUIRED)
 pkg_check_modules(LIBUDEV libudev REQUIRED)
@@ -111,13 +110,11 @@
     message(FATAL_ERROR "systemd is not found w/ pkg-config but SYSTEMD_SERVICES_INSTALL_DIR is defined.")
 endif ()
 
-if(DBUS_FOUND)
-    # Install DBus conf
-    # TODO: Is there a better way of setting the system policy directory?
-    set(DBUS_SYSTEM_POLICY_INSTALL_DIR "/usr/share/dbus-1/system.d")
-    configure_file(logiops-dbus.conf.in ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf)
-    message(STATUS "dbus system policy will be installed at ${DBUS_SYSTEM_POLICY_INSTALL_DIR}")
-    install(FILES ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf
-            DESTINATION ${DBUS_SYSTEM_POLICY_INSTALL_DIR}
-            COMPONENT cp)
-endif()
+# Install DBus conf
+# TODO: Is there a better way of setting the system policy directory?
+set(DBUS_SYSTEM_POLICY_INSTALL_DIR "/usr/share/dbus-1/system.d")
+configure_file(logiops-dbus.conf.in ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf)
+message(STATUS "dbus system policy will be installed at ${DBUS_SYSTEM_POLICY_INSTALL_DIR}")
+install(FILES ${CMAKE_BINARY_DIR}/pizza.pixl.LogiOps.conf
+        DESTINATION ${DBUS_SYSTEM_POLICY_INSTALL_DIR}
+        COMPONENT cp)

=== debian/changelog ===
logiops (0.3.3-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:48:17 +1100

logiops (0.3.3-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:34:28 +0000

logiops (0.3.3-2) unstable; urgency=medium

  * [edacf94] Change systemd build-dep to systemd-dev
    systemd.pc has been split out into the systemd-dev package
    (Closes: #1060616)

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 16 Jan 2024 18:10:02 +0800

logiops (0.3.3-1) unstable; urgency=medium

  * [631ab91] New upstream version 0.3.3

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 17 Jul 2023 15:18:45 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: logiops
 Section: misc
 Priority: optional
-Maintainer: Chow Loong Jin <hyperair@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                dh-exec,
@@ -10,7 +11,7 @@
                libglib2.0-dev,
                libudev-dev,
                libconfig++-dev,
-               systemd
+               systemd-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/PixlOne/logiops
 Vcs-Browser: https://salsa.debian.org/debian/logiops

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"


# GitHub hosted projects
opts="searchmode=plain" \
   https://api.github.com/repos/PixlOne/logiops/releases \
   https://github.com/PixlOne/logiops/releases/download/[^/]+/@PACKAGE@-@ANY_VERSION@\.tar\.gz debian

## logiops 0.3.4

=== debian/changelog ===
logiops (0.3.4-1) unstable; urgency=medium

  * [8b24779] New upstream version 0.3.4

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 04 Jun 2024 22:14:08 +0800

## logiops 0.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
+set(CMAKE_CXX_FLAGS_NONE "${CMAKE_CXX_FLAGS_NONE} -DNDEBUG")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -Wall -Wextra")
 
 set(CMAKE_CXX_STANDARD 20)

=== debian/changelog ===
logiops (0.3.5-1build1) plucky; urgency=medium

  * No-change rebuild for libconfig11.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 27 Jan 2025 19:46:34 +0000

logiops (0.3.5-1) unstable; urgency=medium

  * [ce44b46] New upstream version 0.3.5
    - Fix CVE-2024-45752 (Closes: #1082378)

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 01 Oct 2024 12:43:13 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: logiops
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
+Maintainer: Chow Loong Jin <hyperair@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                dh-exec,

=== debian/tests/control ===
Tests: check-logid
Depends: @
